#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <stdlib.h>

//######### Définition des types #############

typedef struct
{
	char dept[31];
	int nbP;
	char respAd[31];
}Departement;

typedef struct maillonDept
{
	Departement d;
	struct maillonDept *suiv;

}MaillonDept,*ListeDept;

typedef struct
{
	char nom[31];
	ListeDept lDept;
}VilleIUT;

//########## fonction commune ###############
int login(void);
void globale(void);
void clearpage(void);


//########## fonction affichage ##############
void afficherPlace(Departement d);
void afficherDep(Departement d);
void afficherVilleDep(VilleIUT v);

//########## fonction de mise à jour ###########
void miseAJourGlobale(VilleIUT *tiut[], int tLog);
void miseAJourNomDept(Departement d,ListeDept l);
void miseAJourResp(Departement d);
void miseAJourPlaces(Departement d);


//########## fonction de recherche ##############
ListeDept rechercherDept(ListeDept lDept, char dept[], int *trouve);
int rechercheIUT(VilleIUT *tiut[], int tLog, char ville[], int *trouve);

//########## fonction liste ##############
ListeDept listenouv(void);
ListeDept InsererEntete(ListeDept l,int nb);
ListeDept Inserer(ListeDept l, int x);
ListeDept supprimerEntete(ListeDept l);
ListeDept supprimer(ListeDept l, int x);
int longueur(ListeDept l);
bool vide(ListeDept l);
ListeDept ajouterEnqueue(ListeDept l, int x);
int tete(ListeDept l);